/****************************************************************************/
/* Copy the KSCOM.SYS in the Directory and change the CONFIG.SYS            */
/****************************************************************************/
Parse Arg fpwpath fpwlan calledfromSI .
Trace 'O'
Address CMD
'@ECHO OFF'
'CLS'

   Call rxfuncadd sysloadfuncs, rexxutil, sysloadfuncs
   Call sysloadfuncs

   Parse Source key1 key2 key3 key4

   len = Length(key3);
   inst_drw = Substr(key3, 1, len-11);

   badcfg = 'n'

   bootdrive = Substr(Translate(Value('PATH',,'OS2ENVIRONMENT')),Pos('\OS2\SYSTEM',Translate(Value('PATH',,'OS2ENVIRONMENT')))-2,2)

   If inipath = '' Then badcfg = 'y'

   fpwdrive = Substr(fpwpath,1,2)

   If fpwpath <> '' & Substr(fpwdrive,2,1) = ':' Then Do

      If fpwlan = '' Then fpwlan = fpwpath

      inst_path = translate(fpwpath)

      ObjMode="Replace"

      Say ' '
      Say '(C)1995,1997 Copyright KaMell Software GmbH, All rights reserved'
      Say ' '
      Say "Installing..."

      inst_drive = left(inst_path, 2)

      If calledfromSI<>'y' & NeedToCopy(inst_path)='y' Then 
         Call CopyFiles
      Else Do
         Say ' '
         Say '    The program has found the same files that we need for this installation'
         Say '    in the same installation directory!'
         Say '    Should we update them (Y/N)'
         Parse Value SysCurPos() with zeile spalte
         zeile = zeile-1
         pos = SysCurPos(zeile, 32)
         Parse Upper Pull response
         If response <> 'N' Then
            Call CopyFiles 
      End  /* Do */

      Call SysCls

      Call ComportNumber 

      Call SysCls

      Call SerienAktivation

      Call SysCls

      Call UpdateConfig

      inst_drive

      SAY " "

      Call Information

      Say " "
      Say "KaMell Software - KSCOM ..."
      Say "Created successfully!"
 
   End
   Else Do
      Say 'INSTALL.CMD - Rexx script to Install the KSCOM - ISDN Device Driver'
      Say ' '
      Say 'Syntax: INSTALL [PATH]'
      Say '        PATH - KSCOM installation directory'

      Call DriverInfo

      Say ' '
      Say 'Example:'
      Say '        INSTALL C:\OS2'
   End

   Call Endit



/*************************/
/* Set The COMPORT Number*/
/*************************/
ComportNumber:

   Say ' '
   Say '    You can Set the Port Number on which KSCOM will work'
   Say '    Default KSCOM ist set to COM 3!'
   Say ' '
   Say '    Set the Port Number or Press <Enter> for default'
   Say ' '
   Say ' '
   Say '    Portnumber : '

   Parse Value SysCurPos() with zeile spalte
   zeile = zeile - 1
   pos = SysCurPos(zeile, 17)

   Parse Pull port

   If port <> '' Then Do
      if port > 9 Then Do
         Say ' '
         Say '    Not valid Value'
         Say '    KSCOM will be Installed as default on COM3.'
         Say ' '
      End
      Else Do
         Say ' '
         Say '    KSCOM will be Installed as COM'port'.'
         Say ' '
      End
   End
   Else Do
      Say ' '
      Say '    KSCOM will be Installed as default on COM3.'
      port = 0
   End

   Say ' '
   Say ' '
   Say '  Press <Enter> to Continue !'

   Pull

   return 0


/*******************************************/
/* Set The Seriennumber and Activation Key */
/*******************************************/
SerienAktivation:

   Say ' '
   Say '    Please enter the Seriennumber and the Activation Key !'
   Say ' '
   Say '    Press <Enter> for Demo Version'
   Say ' '

   Say '    Seriennumber  : '

   Parse Value SysCurPos() with zeile spalte
   zeile = zeile - 1
   pos = SysCurPos(zeile, 20)

   Parse Pull seriennumber

   If seriennumber == '' Then Do
      Say ' '
      Say '    Note: Demoversion will expire in 30 Days'
      Say '          You can establish only:'
      Say '          5  - Activconnections  (Send) and'
      Say '          25 - Passivconnections (Receive) !'
      Say ' '
      
      seriennumber  = ''
      aktivationkey = ''

      Say ' '
      Say ' '
      Say '  Press <Enter> to Continue !'

      Pull

      return 0
   End

   Say ' '
   Say '    Aktivationkey : '

   Parse Value SysCurPos() with zeile spalte
   zeile = zeile - 1
   pos = SysCurPos(zeile, 20)

   Parse Pull aktivationkey
   If aktivationkey == '' Then Do
      Say ' '
      Say '  ERROR : With no Aktivationkey KSCOM wil be Installed as Demoversion!'
      Say ' '
      Say '    Note: Demoversion will expire in 30 Days'
      Say '          and You can start just 5 Activconnections and'
      Say '          Receive 25 Pasivconnections !'
      Say ' '
      seriennumber  = ''
      aktivationkey = ''
   End

   Say ' '
   Say ' '
   Say '  Press <Enter> to Continue !'

   Pull

   return 0



/*************************/
/* Change the CONFIG.SYS */
/*************************/
UpdateConfig:
response=''
/*
   Say ' '
   Say '    Do you want to update 'bootdrive'\CONFIG.SYS?(Y/N)'
   Parse Value SysCurPos() with zeile spalte
   zeile = zeile-1
   pos = SysCurPos(zeile, 47)
   Parse Upper Pull response
   If response = 'N' Then Do
      return 0
   End  /* Do */
*/
   Say ' '
   Say '    The old 'bootdrive'\CONFIG.SYS has been changed und renamed to 'bootdrive'\CONFIG.BIN'

   oldconfig=bootdrive'\CONFIG.SYS'
   newconfig=bootdrive'\CONFIG.BIN'
   tmpconfig=bootdrive'\CONFIG.XXX'

   os2device='DEVICE'

   deviceflag=0

   /* get the portion of pathspec without the [drive]: */
   pathonly = right(fpwpath, length(fpwpath)-2)

   /*
    * read the file one line at a time, and write it all out, making
    * the necesery changes accordingly for the BIANCA devices
    */

   '@del 'newconfig ' 2>nul >nul'

   Do while lines(oldconfig)
      exist = 0
      inline=linein(oldconfig)
      ksline=inline

      /******************************************/
      /* parse the line into variable and value */
      /******************************************/

      parse value inline with os2var '=' '/' os2value comvalue

      /********************************************************/
      /* translate the variable into uppercase for comparison */
      /********************************************************/

      os2var=translate(os2var)


      /********************************************************/
      /*          For DEVICE= ...\KSCOM.SYS                 */
      /********************************************************/
         if os2var=os2device Then Do

            /* see if path is already set */
            k = pos(pathonly, translate(ksline))
            If k = 0 Then Do
               /* see if there is a BRICAPI.SYS at the end of the value */
               b_temp = right(os2value, 9)

               b_temp = translate(b_temp)

               If b_temp = 'KSCOM.SYS' Then do
                  exist = 1
               End
               Else Do
                  exist = 0
               End
               
            End
            Else  /* see if the drive letter is not the same */
              If substr(ksline, k-2, 1) \= fpwdrive Then
                /* change the drive letter only */
                ksline = overlay(fpwdrive, ksline, k-2)

         End

            /*
             * write the line out to the new config file
             */
            result = 0

            if exist = 0 then
               result=lineout(newconfig, ksline)

            If result=1 Then Do
                writeerror()
                return 1
            End

   End /* Do */

   string = ''
   rc = lineout(newconfig,string)

   string = 'REM ***** The Changes needed for KSCOM Begin *****'
   rc = lineout(newconfig,string)

   If seriennumber <> '' Then Do
      ser_akt = '/S:'seriennumber' /A:'aktivationkey 
   End
   Else Do
      ser_akt = ''
   End


   If port <> 0 Then Do
      string = 'DEVICE='inst_path'\KSCOM.SYS /P:COM'port ser_akt
   End
   Else Do
      string = 'DEVICE='inst_path'\KSCOM.SYS' ser_akt
   End

   rc = lineout(newconfig,string)

   string = 'REM ***** The Changes needed for KSCOM End *****'
   rc = lineout(newconfig,string)

   /*********************/
   /* close the files   */
   /*********************/

   result=lineout(newconfig)
   result=lineout(oldconfig)


   /******************************************************************/
   /* Copy created   file(CONFIG.BIN)  to temporary file(CONFIG.XXX), */
   /* copy original  file(CONFIG.SYS) to new       file(CONFIG.BIN),  */
   /* copy temporary file(CONFIG.XXX) to original  file(CONFIG.SYS). */
   /******************************************************************/

   '@copy 'oldconfig' 'tmpconfig' 2>nul >nul'

   '@copy 'newconfig' 'oldconfig' 2>nul >nul'

   '@copy 'tmpconfig' 'newconfig' 2>nul >nul'

   '@del 'tmpconfig' 2>nul >nul'

   /******************************************************************/
   /*  Finished the Update                                           */
   /******************************************************************/

   Say ' '
   Say '    'bootdrive'\CONFIG.SYS updated successfully.'
   Say ' '

   return 0



/***************/
/* Information */
/***************/
Information:
   Say '    Shutdown your system to let the changes take effect!'

   return 0



/********************/
/* Should we copy ? */
/********************/
NeedToCopy: procedure
ARG inst_path
   rc = 'n'

   ret = SysFileTree(inst_path'\KSCOM.SYS', 'file', 'FO')
   If file.0 = 0 Then
      rc = 'y'
      
   return rc   


/********************/
/* Copy the Files   */
/********************/
CopyFiles:

   Say ' '
   Say 'Copying ... '

   Say ' '
   Say '  Creating Directory 'fpwlan   
   call SysMkDir fpwlan


   Say ' '
   Say '    Copy 'inst_drw'KSCOM.SYS into 'fpwlan
   '@copy 'inst_drw'KSCOM.SYS 'fpwlan

   Say ' '
   Say ' '
   Say '  Press <Enter> to Continue !'

   Pull

   return 0



/********************/
/* Drive     Info   */
/********************/
DriverInfo:

   driver_name = SysDriveMap('C:', 'USED')
   pos = 1
   Say ' '
   Say '        Driver  Free         Used         Drivername'

   again:
      letter = SubStr(driver_name, pos, 2)
      if letter <> ' ' Then Do
         pos=pos+3
         Say '            'SysDriveInfo(letter)
         Call again
      End

   return 0



/****************/
/* Exit program */
/****************/
Endit:
   Exit 0
